import java.awt.*;
import javax.swing.*;
import java.net.URL;

/**
 *  Description of the Class
 *
 * @author     Silvio Evangelista
 * @created    10 de Setembro de 2008
 */
public class HTToolBar extends JToolBar {

    /**
     *Constructor for the HTToolBar object
     *
     * @param  view  Description of the Parameter
     */
    public HTToolBar(HTView view) {
        String[] imageFiles = {"gravar1.gif", "xml1.gif", "separator", "inserir1.gif",
            "editar1.gif", "copiar1.gif", "colar1.gif", "colarE.gif", "colarED.gif",  "web.gif", "undo1.gif", "separator", "hiper.jpg", "remover1.gif", "separator", "center1.gif", "link.gif", "folder.gif", "publish1.png"
        };
        String[] toolbarLabels = {"Gravar rvore", "Gravar formato XML", "separator", "Inserir/Editar Metadado", "Editar", "Copiar", "Colar", "Colar Arco", "Colar Arco Direcionado", "Executar 'Crawling'",
            "Recuperar", "separator", "Mesclar rvores", "Remover", "separator", "Centralizar a rvore", "Verificar links quebrados", "Gerar Folder Tree", "Configurar"
        };
        Insets margins = new Insets(0, 0, 0, 0);
        for (int i = 0; i < toolbarLabels.length; i++) {
            //ToolBarButton button =
            //new ToolBarButton("images/" + imageFiles[i]);
            try {
                if (!(imageFiles[i].toLowerCase().equals("separator"))) {
                    URL imageURL = getClass().getResource("images/" + imageFiles[i]);
                    ToolBarButton button = new ToolBarButton(imageURL);
                    button.setToolTipText(toolbarLabels[i]);
                    button.setMargin(margins);
                    add(button);
                    button.addActionListener(view.getAction());
                    view.setButtonGeneric(toolbarLabels[i], button);
                } else {
                    addSeparator();
                }
            } catch (Exception e) {
                System.out.println(e.toString());
            }
        }
        addSeparator();
        JCheckBox cb = new JCheckBox("duplo click: insere", null, true);
	JCheckBox cb1 = new JCheckBox("Mostra Grafo", null, true);
        cb.addActionListener(view.getAction());
        view.setCheckbox(cb);
        add(cb);
	cb1.addActionListener(view.getAction());
        view.setCheckbox1(cb1);
        add(cb1);

    }

    /**
     *  Description of the Method
     */
    public void separator() {
        addSeparator();
    }

    /**
     *  Sets the textLabels attribute of the HTToolBar object
     *
     * @param  labelsAreEnabled  The new textLabels value
     */
    public void setTextLabels(boolean labelsAreEnabled) {
        Component c;
        int i = 0;
        while ((c = getComponentAtIndex(i++)) != null) {
            ToolBarButton button = (ToolBarButton) c;
            if (labelsAreEnabled) {
                button.setText(button.getToolTipText());
            } else {
                button.setText(null);
            }
        }
    }
    /*
     *  public boolean isOptimizedDrawingEnabled() {
     *  return false;
     *  }
     */
}

