/*
 * HTApplet.java
 *
 * The MIT License :
 * -----------------
 * Copyright (c) 2005 Embrapa Informtica Agropecuria
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
//package hypertree.demo;

//import hypertree.HyperTree;
//import hypertree.HTView;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.applet.*;
import java.awt.*;
import java.net.URL;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * The Demo class implements a demo for HyperTree. It display an HyperTree
 * view of a demo tree.
 * The demo tree is build from a file tree, passed in parameter.
 * Demo could take an argument, the path from which 
 * start the representing of files.
 * If no arguments is given, the treemap start from the root.
 */
public class HTApplet extends Applet
        implements ActionListener {

    private static HTFileNode root = null; // the root of the demo tree
    private static HyperTree hypertree = null; // the hypertree builded
    private static HTView view;    //TextField nomeField;
    TextField corField;
    TextField corText;
    TextField hintField;
    TextField urlField;
    TextField textField;
    int ntNos = 0;
    Panel panel;
    Label corLabel;
    Label corTextLabel;
    Label hintLabel;
    Label urlLabel;
    Label textLabel;
    private int undoControlAtual = 0;
    private int undoControlBase = 0;
    private Image imageH;
    private Image imageO;
    private Image imageC;
    private Image imageA;
    private Image imageB;
    private Image imageS;
    static JFrame viewFrame,  viewFrameOld; // Silvio 19/09/2006
    String htFile;
    String htHintColor;
    String htCenterNode;
    String htBackColor;
    String htBackColorEdit;
    String htLinkColor;
    String htSearchColor;
    String htGraphColor;
    String htBorderType;
    String htFont;
    String htFontSize;
    String htHomeImage;
    String htConfirmarImage;
    String htCancelarImage;
    String htAplicarImage;
    String curDir = "";
    String htHelpImage;
    String htBackImage;
    String htHelpFile;
    String htUrlAdr;
    String pathRoot = null;
    JMenuBar menubar;
    HTVector graph = null;
    boolean lineGraph;

    public HTApplet() {
    }

    protected Button makebutton(String name, GridBagLayout gridbag, GridBagConstraints c, Panel panel, String hint) {
        Button button = null;
        return button;
    }

    protected void makeLabel(String name, GridBagLayout gridbag, GridBagConstraints c, double d) {
    }

    protected void makeMenuBar(JFrame jframe) {
    }

    protected void makeLabelR(String name, GridBagLayout gridbag, GridBagConstraints c, double d) {
    }

    protected void makeInterfaceEditor(JFrame viewFrame) {
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        Panel panel = new Panel();
        panel.setSize(new Dimension(viewFrame.getWidth(), 128));
        panel.setLayout(gridbag);
        panel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        view.setPanel(panel);

        panel.setVisible(false);

        viewFrame.getContentPane().add(panel);

        c.weightx = 0;
        c.insets = new Insets(4, 0, 4, 0);

        c.anchor = GridBagConstraints.EAST;

        textLabel = new Label("Nome:", 2);
        textLabel.setFont(new Font("Serif", Font.PLAIN, 12));
        textLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        if (htBackColorEdit.trim().equals("0x000000")) {
            textLabel.setForeground(Color.white);
        } else {
            textLabel.setForeground(Color.black);
        }
        view.setTextLabel(textLabel);
        gridbag.setConstraints(textLabel, c);
        panel.add(textLabel);

        textField = new TextField(16);
        textField.setFont(new Font("Serif", Font.PLAIN, 12));

        textField.setBackground(Color.lightGray);
        view.setTextField(textField);
        gridbag.setConstraints(textField, c);
        panel.add(textField);

        c.anchor = GridBagConstraints.EAST;
        corLabel = new Label("  Cor:", 2);
        corLabel.setFont(new Font("Serif", Font.PLAIN, 12));
        corLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

        if (htBackColorEdit.trim().equals("0x000000")) {
            corLabel.setForeground(Color.white);
        } else {
            corLabel.setForeground(Color.black);
        }
        view.setCorLabel(corLabel);
        gridbag.setConstraints(corLabel, c);
        panel.add(corLabel);

        c.anchor = GridBagConstraints.CENTER;
        corField = new TextField(8);
        corField.setFont(new Font("Serif", Font.PLAIN, 12));
        corField.setBackground(Color.lightGray);
        view.setCorField(corField);
        gridbag.setConstraints(corField, c);
        panel.add(corField);
        corField.setEnabled(true);

        view.setCorF(makebutton("...", gridbag, c, panel, "Definir a cor do n."));

        view.setAplicarF(makebutton("Aplicar aos Filhos", gridbag, c, panel, "Aplicar a cor escolhida a todos os filhos do n selecionado."));

        corTextLabel = new Label("  Cor Texto:", 2);
        corTextLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

        if (htBackColorEdit.trim().equals("0x000000")) {
            corTextLabel.setForeground(Color.white);
        } else {
            corTextLabel.setForeground(Color.black);
        }
        view.setCorTextLabel(corTextLabel);
        gridbag.setConstraints(corTextLabel, c);
        panel.add(corTextLabel);

        c.anchor = GridBagConstraints.CENTER;
        corText = new TextField(8);
        corText.setFont(new Font("Serif", Font.PLAIN, 12));
        corText.setBackground(Color.lightGray);
        view.setCorText(corText);
        gridbag.setConstraints(corText, c);
        panel.add(corText);

        corText.setEnabled(true);

        view.setCorT(makebutton("...", gridbag, c, panel, "Definir a cor do texto."));

        view.setAplicarT(makebutton("Aplicar aos Filhos", gridbag, c, panel, "Aplicar a cor escolhida a todos os filhos do n selecionado."));

        c.gridwidth = GridBagConstraints.REMAINDER; //end row 
        Label dummy = new Label(" ");
        dummy.setFont(new Font("Serif", Font.PLAIN, 12));
        dummy.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        view.setCorTextLabel(dummy);
        gridbag.setConstraints(dummy, c);
        panel.add(dummy);

        c.gridwidth = 1; // GridBagConstraints.RELATIVE; //next-to-last in row
        hintLabel = new Label(" Hint: ");
        hintLabel.setFont(new Font("Serif", Font.PLAIN, 12));
        hintLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));

        if (htBackColorEdit.trim().equals("0x000000")) {
            hintLabel.setForeground(Color.white);
        } else {
            hintLabel.setForeground(Color.black);
        }
        view.setHintLabel(hintLabel);

        gridbag.setConstraints(hintLabel, c);
        panel.add(hintLabel);

        c.gridwidth = GridBagConstraints.REMAINDER; //end row 

        hintField = new TextField(90);
        hintField.setFont(new Font("Serif", Font.PLAIN, 12));
        hintField.setBackground(Color.lightGray);
        view.setHintField(hintField); // **

        gridbag.setConstraints(hintField, c);
        panel.add(hintField);

        c.gridwidth = 1; // GridBagConstraints.SOUTHWEST;//RELATIVE; //next-to-last in row

        /* Bruno
         * Trecho de codigo substituido pelo form de URLs
         *
        urlLabel = new Label(" URL: ");
        urlLabel.setFont(new Font("SansSerif", Font.BOLD, 11));
        urlLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        
        if (htBackColorEdit.trim().equals("0x000000")) {
        urlLabel.setForeground(Color.white);
        } else {
        urlLabel.setForeground(Color.black);
        }
        view.setURLLabel(urlLabel);
        
        gridbag.setConstraints(urlLabel, c);
        panel.add(urlLabel);
        
        c.gridwidth = GridBagConstraints.REMAINDER;
        //end row
        urlField = new TextField(90);
        urlField.setFont(new Font("SansSerif", Font.PLAIN, 11));
        urlField.setBackground(Color.lightGray);
        view.setURLField(urlField);
        
        gridbag.setConstraints(urlField, c);
        panel.add(urlField);
         */

        // Precisa criar, se nao nao aparece as opcoes de editar
        view.setURLField(new TextField(""));

        // Cria o botao que abre o form
        Button btnNovoLink = new Button("Novo Link");
        //btnNovoLink.setText("Novo Link");
        btnNovoLink.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNovoLinkActionPerformed(evt);
            }
        });
        panel.add(btnNovoLink);

        // Fim Bruno

        c.anchor = GridBagConstraints.CENTER;
        c.ipady = 12;
        c.ipadx = 12;
        c.gridwidth = 4;//GridBagConstraints.RELATIVE; //next-to-last in row

        view.setOk(makebutton("   OK   ", gridbag, c, panel, "Aplicar alteraes ao n selecioando"));
        view.setCancel(makebutton("Cancelar", gridbag, c, panel, "No Aplicar alteraes ao n selecioando"));
    }

    /*
     * Bruno
     * 
     * Funcao que trata o clique no botao de Links
     */
    private void btnNovoLinkActionPerformed(java.awt.event.ActionEvent evt) {
        Frame f = new Frame("Ateno");
        HTDialogURLs urls = new HTDialogURLs(f, view);
       // urls.show();
    }

    HTVector getGraph() {
	return graph;
    }

    // Fim Bruno
    public void init() {
	graph = new HTVector();
        pathRoot = null;
        htFile = getParameter("htfile");
        htHintColor = getParameter("hthintcolor");
        htCenterNode = getParameter("htcenternode");
        htBackColor = getParameter("htbackcolor");
        htBackColorEdit = getParameter("htbackcoloredit");
        htLinkColor = getParameter("htlinkcolor");
        htSearchColor = getParameter("htsearchcolor");
        htBorderType = getParameter("htbordertype");
        htFont = getParameter("htfont");
        htFontSize = getParameter("htfontsize");
        htHomeImage = getParameter("hthomeimage");
        htConfirmarImage = getParameter("htconfirmarimage");
        htCancelarImage = getParameter("htcancelarimage");
        htAplicarImage = getParameter("htaplicarimage");
        htHelpImage = getParameter("hthelpimage");
        htBackImage = getParameter("htbackimage");
        htHelpFile = getParameter("hthelpfile");
        htUrlAdr = getParameter("hturladr");


        if (htFile == null) {
            System.out.println("Arquivo com a rvore Hiperblica no foi especificado");
            return;
        }

//	try {
//	      if( Class.forName("netscape.security.PrivilegeManager") != null )
//    			netscape.security.PrivilegeManager.enablePrivilege("UniversalAwtEventQueueAccess");//
//	} catch (Exception e) {
//    		// privilege is not currently granted
//	}

        try {
            URL url = new URL(getCodeBase(), "");
            curDir = url.getPath();
            if ((curDir.charAt(0) == '/') && curDir.toLowerCase().indexOf("c:") >= 0) {
                curDir = curDir.substring(1);
            }
            curDir = curDir.trim();
            curDir = curDir.replaceAll("%20", " ");

            System.out.println(System.getProperty("java.vm.version"));

            // Criando, se necessrio, diretrio para operao de UNDO
            boolean success = (new File("undo")).mkdir();

        } catch (Exception e) {
            System.out.println(e.toString());
        }

        try {
            GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), htFile)).openStream());
            ObjectInputStream pi = new ObjectInputStream(zip);
            root = (HTFileNode) pi.readObject();
            zip.close();
        } catch (Exception e) {
            root = new HTFileNode();
            HTFileNode filho = new HTFileNode();


            String id = "_1";
            root.setID(id);
            root.setColor("0xFF0000");//nodeColorDefault);
            root.setTextColor("0xFFFF00");
            root.setName("Raiz ");
            root.setLeafNode(false);

            //Hashtable ht = new Hashtable();

            //ht.put(id,root);

            filho.setID("_2");
            filho.setColor("0x00FF00");//nodeColorDefault);
            filho.setTextColor("0xFF0000");
            filho.setName("Filho 1 ");
            filho.setLeafNode(true);

            //ht.put("_2", filho);				

            root.addChild(filho);

        //root = (HTFileNode) ht.get(id);

        //System.out.println("Leitura de Objetos  :  " + e.toString());
        //return;
        }

        if (root == null) {
            System.err.println("Erro : No foi possvel iniciar a rvore Hiperblica");
            return;
        } else {
            try {
                GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(curDir + "undo/" + htFile + ".bac"));
                ObjectOutputStream po = new ObjectOutputStream(zip);
                resetMark(root);
                po.writeObject(root);
                zip.close();
            } catch (Exception e) {
                System.out.println("\nGrava de Objetos  :" +
                        e.toString());
            }
        }

        hypertree = new HyperTree(root, this);

        view = hypertree.getView();
        view.setApplet(this);

        if (htHintColor != null) {
            view.setHintColor(htHintColor);
        }
        if (htBackColor != null) {
            view.setBackColor(htBackColor);
        }
        if (htBackColorEdit != null) {
            view.setBackColorEdit(htBackColorEdit);
        } else {
            htBackColorEdit = "0x222222";
            view.setBackColorEdit(htBackColorEdit);
        }

        if (htLinkColor != null) {
            view.setLinkColor(htLinkColor);
        }
        if (htSearchColor != null) {
            view.setSearchColor(htSearchColor);
        }
        if (htBorderType != null) {
            view.setBorderType(htBorderType);
        }
        if (htCenterNode != null) {
            view.setCenterNode(htCenterNode);
        }
        if (htHelpFile != null) {
            view.setHelpFile(htHelpFile);
        }

        if (htUrlAdr != null) {
            view.setUrlAdr(htUrlAdr);
        }
        if (htFont != null) {
            view.setFontNode(htFont);
        } else {
            view.setFontNode("Serif");
        }
        if (htFontSize != null) {
            view.setFontSizeNode(((new Integer(htFontSize)).intValue()));
        } else {
            view.setFontSizeNode(12);
        }
        if (htHomeImage != null) {
            imageH = getImage(getCodeBase(), htHomeImage);
            if (imageH != null) {
                view.setHomeImage(imageH);
            }
        } else {
        }

        if (htConfirmarImage != null) {
            imageO = getImage(getCodeBase(), htConfirmarImage);
            if (imageO != null) {
                view.setConfirmarImage(imageO);
            }
        } else {
        }
        if (htCancelarImage != null) {
            imageC = getImage(getCodeBase(), htCancelarImage);
            if (imageC != null) {
                view.setCancelarImage(imageC);
            }
        } else {
        }
        if (htAplicarImage != null) {
            imageA = getImage(getCodeBase(), htAplicarImage);
            if (imageA != null) {
                view.setAplicarImage(imageA);
            }
        } else {
        }


        if (htBackImage != null) {
            imageB = getImage(getCodeBase(), htBackImage);
            if (imageB != null) {
                view.setBackImage(imageB);
            }
        } else {
        }

        if (htHelpImage != null) {
            imageS = getImage(getCodeBase(), htHelpImage);
            if (imageS != null) {
                view.setHelpImage(imageS);
            }
        } else {
        }


        // AWT - PAnel

        setLayout(new BorderLayout());

        setBackground(Color.lightGray);//new Color (Color.decode(view.getBackColor()).getRGB())); 

        setSize(new Dimension(120, 120));

        //add("Center", view); 


        setVisible(false); // Era True

        viewFrame = new JFrame(root.getName());

        viewFrame.setContentPane(view);
        viewFrame.setSize(800, 600);
        viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

        makeInterfaceEditor(viewFrame);
        view.setViewFrame(viewFrame);
        makeMenuBar(viewFrame);
        viewFrame.setJMenuBar(menubar);
        viewFrame.setVisible(true);
    //makeMenuBar(viewFrame);
    //viewFrame.setJMenuBar(menubar);	
    //viewFrame.setVisible(true);  

    }

    public final void setVisibles() {
        viewFrame.setJMenuBar(menubar);
        viewFrame.setVisible(true);
    }

    public final void reLoad(String center) {
        //this.destroy();

        //hypertree   = new HyperTree(root, this);

        hypertree.setNewHyperTree(root, this);

        //view.destroy();

        boolean isEdited = view.getIsEdited();

        view = null;

        System.gc();

        view = hypertree.getView();

        view.setApplet(this);

        if (htHintColor != null) {
            view.setHintColor(htHintColor);
        }
        if (htBackColor != null) {
            view.setBackColor(htBackColor);
        }
        if (htLinkColor != null) {
            view.setLinkColor(htLinkColor);
        }
        if (htSearchColor != null) {
            view.setSearchColor(htSearchColor);
        }
        if (htBorderType != null) {
            view.setBorderType(htBorderType);
        }
        if (center != null) {
            view.setCenterNode(center);
        }
        if (htHelpFile != null) {
            view.setHelpFile(htHelpFile);
        }

        if (htUrlAdr != null) {
            view.setUrlAdr(htUrlAdr);
        }
        if (htFont != null) {
            view.setFontNode(htFont);
        } else {
            view.setFontNode("Serif");
        }
        if (htFontSize != null) {
            view.setFontSizeNode(((new Integer(htFontSize)).intValue()));
        } else {
            view.setFontSizeNode(12);
        }
        if (htHomeImage != null) {
            imageH = getImage(getCodeBase(), htHomeImage);
            if (imageH != null) {
                view.setHomeImage(imageH);
            }
        } else {
        }

        if (htConfirmarImage != null) {
            imageO = getImage(getCodeBase(), htConfirmarImage);
            if (imageO != null) {
                view.setConfirmarImage(imageO);
            }
        } else {
        }
        if (htCancelarImage != null) {
            imageC = getImage(getCodeBase(), htCancelarImage);
            if (imageC != null) {
                view.setCancelarImage(imageC);
            }
        } else {
        }
        if (htAplicarImage != null) {
            imageA = getImage(getCodeBase(), htAplicarImage);
            if (imageA != null) {
                view.setAplicarImage(imageA);
            }
        } else {
        }


        if (htBackImage != null) {
            imageB = getImage(getCodeBase(), htBackImage);
            if (imageB != null) {
                view.setBackImage(imageB);
            }
        } else {
        }

        if (htHelpImage != null) {
            imageS = getImage(getCodeBase(), htHelpImage);
            if (imageS != null) {
                view.setHelpImage(imageS);
            }
        } else {
        }


        setLayout(new BorderLayout());

        setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

        //setSize(new Dimension(800, 600));

        //add("Center", view); 	  	 

        //setVisible(true);

// Remoo do Frame Anterior
        int h, w, x, y;
        h = viewFrame.getHeight();
        w = viewFrame.getWidth();
        x = viewFrame.getX();
        y = viewFrame.getY();

// Troquei em 07/07/2003 por este cdigo. Aqui eu armazeno viewFrame para depois remov-lo.

        viewFrameOld = viewFrame;

//	  viewFrame.removeAll();
//	  viewFrame.dispose();

// Fim Remoo

        viewFrame = new JFrame(root.getName());

        viewFrame.setContentPane(view);

//	  if (w < 800) w = 800;
//	  if (h < 600) h = 600;

        viewFrame.setSize(w, h);
        viewFrame.setLocation(x, y);


        viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

        makeInterfaceEditor(viewFrame);

        view.setViewFrame(viewFrame);

        makeMenuBar(viewFrame);

        viewFrame.setJMenuBar(menubar);
        viewFrameOld.removeAll();
        viewFrameOld.dispose();

        viewFrame.setVisible(true);


    }

    public void percorre(HTFileNode node, int ind) {

        String b = "";

        for (int i = 0; i < ind; i++) {
            b = b + "    ";        //System.out.println(b + node.getID() + " " + node.getName() + " " + node.getColor()); 
        }
        ntNos++;

        for (Enumeration e = node.children(); e.hasMoreElements();) {
            ntNos++;
            HTFileNode childNode = (HTFileNode) e.nextElement();

            if (!childNode.isLeaf()) {
                ind = ind + 1;
                percorre(childNode, ind);
                ind = ind - 1;
            } else {
                ind = ind + 1;
                b = "";
                for (int i = 0; i < ind; i++) {
                    b = b + "    ";
                //System.out.println(b+ " >> " + childNode.getID() + " " + childNode.getName() + " " + childNode.getHint()); 					
                }
                ind = ind - 1;
            }
        }

    }

    /*           
    
    // Silvio 19/09/2006
    public final void paint(Graphics g)
    {        
    if (f != null) f.doFront();
    super.paint(g);
    }
    public final void update(Graphics g)
    {
    
    super.paint(g);
    
    }
    public final void paint(Graphics g)
    {        
    
    super.paint(g);
    }
    
    public void paint(Graphics g) {//conteudo 
    //g.setColor(Color.red); 
    //g.drawString("Eu sou uma applet",25,45); 
    //g.setColor(Color.green); 
    //g.drawString("que desenha um retangulo",45,75); 
    //g.setColor(Color.orange); 
    //g.drawRect(200,50,30,40); 
    view.paintComponent(g);
    
    } 
    
    
    public void start() {//conteudo 
    show();
    requestFocus();
    }
    
    
    public void stop() {//conteudo 
    HTFileNode hNodeF = (HTFileNode) ht.get(idRoot);
    resetMark(hNodeF);
    try {			
    GZIPOutputStream zip  = new GZIPOutputStream(new FileOutputStream(curDir+file + ".htz")); 
    ObjectOutputStream po = new ObjectOutputStream(zip); 				
    po.writeObject(hNodeF); 				
    zip.close();
    
    } catch (Exception e) {
    System.out.println("\nGrava de Objetos  :"+
    e.toString());
    }
    
    destroy();
    }
    
    public void paint(Graphics g) {//conteudo 
    g.setColor(Color.red); 
    g.drawString("Eu sou uma applet",25,45); 
    
    for (int i=0; i < 10000000; );
    
    view.paintComponent(g);
    } 
    
     */
    public void stop() {//conteudo 

        try {
            String folder = curDir;//System.getProperty("user.dir")+System.getProperty("file.separator");	  
            GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + htFile));
            ObjectOutputStream po = new ObjectOutputStream(zip);
            resetMark(root);
            po.writeObject(root);
            zip.close();

        } catch (Exception e) {
            System.out.println("\nGrava de Objetos  :" +
                    e.toString());
        }

        destroy();

    //percorre(root, 0);

    //System.out.println("N. elementos: " + ntNos);

    }

    public void undoRecupera() {
        undoControlAtual--;
        if (undoControlAtual < 0) {
            if (undoControlBase > 0) {
                undoControlAtual = 9;
            } else {
                undoControlAtual = 0;
                return;
            }
        }
        try {
            GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), "undo/" + htFile + "." + undoControlAtual)).openStream());
            ObjectInputStream pi = new ObjectInputStream(zip);
            root = (HTFileNode) pi.readObject();
            zip.close();

        } catch (Exception e) {
            System.out.println("\nGrava de Objetos  :" +
                    e.toString());
        }
    }

    public void undoGrava() {

        try {
            String folder = curDir;//System.getProperty("user.dir")+System.getProperty("file.separator");	  
            GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + "undo/" + htFile + "." + undoControlAtual));
            ObjectOutputStream po = new ObjectOutputStream(zip);
            resetMark(root);
            po.writeObject(root);
            zip.close();

        } catch (Exception e) {
            System.out.println("\nGrava de Objetos  :" +
                    e.toString());
        }
        undoControlAtual++;
        if (undoControlAtual > 9) {
            undoControlBase = 1;
            undoControlAtual = 0;
        }
    }

    public void grava() {
        String folder = "";
        try {
            folder = curDir;//System.getProperty("user.dir")+System.getProperty("file.separator");
            GZIPOutputStream zip = new GZIPOutputStream(new FileOutputStream(folder + htFile));

            ObjectOutputStream po = new ObjectOutputStream(zip);
            resetMark(root);
            po.writeObject(root);
            zip.close();

        } catch (Exception e) {
            System.out.println("\nGrava de Objetos  :" +
                    e.toString());
        }
        System.out.println("Hipertree Gravada em " + folder + htFile);
    }    // Silvio 19/09/2006
    static int nTentativas = 0;
    static int nThreads = 0;
    static int nQueb = 0;

    // Silvio 19/09/2006
    public void resetMark(HTFileNode node) {
        for (Enumeration e = node.children(); e.hasMoreElements();) {
            HTFileNode childNode = (HTFileNode) e.nextElement();

            if (!childNode.isLeaf()) {
                childNode.setEspecialMark(false);
                resetMark(childNode);
            } else {
                childNode.setEspecialMark(false);
            }
        }

    }

    class verThread implements Runnable { //extends Thread {

        String link;
        HTFileNode childNode;
        int nTentativas;

        verThread(String ll, HTFileNode child, int nt) {
            this.link = ll;
            this.childNode = child;
            this.nTentativas = nt;
        }

        public void run() {

            String cor = childNode.getColor();
            try {
                if (getNThreads() <= 2) {
                    Thread.sleep(1000);
                }
                if ((nTentativas <= 1) || (nTentativas > 1 && childNode.getEspecialMark())) {

                    URL encontrado = new URL(link);
                    BufferedReader in = new BufferedReader(new InputStreamReader(encontrado.openStream()));
                    if (in.toString().toLowerCase().indexOf("404") >= 0 && in.toString().toLowerCase().indexOf("not") >= 0 && in.toString().toLowerCase().indexOf("found") >= 0) {
                        childNode.setEspecialMark(true);

                    }
                    in.close();
                    childNode.setEspecialMark(false);

                }
                decnThreads();
            } catch (Exception e2) {
                decnThreads();
                incQueb();
                childNode.setEspecialMark(true);

            }
        }
    }

    static int getNThreads() {
        return (nThreads);
    }

    static void decnThreads() {
        nThreads--;
        view.setNThreads(nThreads);
        if (nThreads == 0) {
            view.enableVerificarLinks();
            view.repaint();
            if (nTentativas <= 1) {
                putDialog("Execuo " + nTentativas + ". Processo de verificao dos 'links' est finalizado. Foram encontrados " + nQueb + " 'links' quebrados.");
            } else {
                putDialog("Execuo " + nTentativas + ". Processo de verificao dos 'links' est finalizado. Foram encontrados " + nQueb + " 'links' quebrados." +
                        "Obs: apenas os  'links' quebrados anteriormente foram verificados nesta execuo");
            }
        } else {
            view.repaint();
        }
    }

    static void incQueb() {
        nQueb++;
    }

    public void verificaLinks1(HTFileNode node, int ind) {

        for (Enumeration e = node.children(); e.hasMoreElements();) {

            if (continua == false) {
                break;
            }
            HTFileNode childNode = (HTFileNode) e.nextElement();
            String link = childNode.getURL();
	

            if (link != null && link.trim().length() > 4) {
                try {
                    //childNode.setEspecialMark(true);
                    String base = view.getUrlAdr();

                    if ((base.length() > 2) && (link.toLowerCase().indexOf("http:") < 0)) {
                        if ((link.charAt(0) != '/') && (base.charAt(base.length() - 1) != '/')) {
                            link = base + "/" + link;
                        } else {
                            link = base + link;
                        }
                    }

                    nThreads++;
                    Thread t = new Thread(new verThread(link, childNode, nTentativas));
                    t.start();

                } catch (Exception e2) {
                }
            } else {
            }

            if (!childNode.isLeaf()) {
                ind = ind + 1;
                verificaLinks1(childNode, ind);
                ind = ind - 1;
            }
        }
    }
    private boolean continua = true;
    private ThreadGroup grupo;

    public void verificaLinks() {

        if ((view != null) && (nThreads == 0)) {
            view.disableVerificarLinks();
            nQueb = 0;
            nTentativas++;
            verificaLinks1(root, 0);
        }
    }

    public void folderTree() {
    }
	
		public void configNavegador() {
	}
	public void sethtBackImage(String img) {
		htBackImage = img;
	}
	
		public String gethtBackImage() {
		return htBackImage;
	}
	
		public void sethtBackColor(String cor) {
		htBackColor = cor;
	}
	
	public String gethtBackColor() {
		return htBackColor;
	}
	
    public void webCrawling(String id) {
    }

    static void putDialog(String texto) {


        // Create an instance of InfoDialog, with title and message specified
        HTDialogYesNo d =
                new HTDialogYesNo(viewFrame, "Informao",
                texto,
                null,
                "OK",
                null);

        // Register an action listener for the dialog.  This one just prints
        // the results out to the console.
        d.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                String answer = e.getActionCommand();

                if (answer.equals("yes")) {
                    //continua=false;
                }
            }
        });

        d.show();

    }
// Silvio
    public boolean hasUndo() {
        if ((undoControlAtual == 0) && (undoControlBase == 0)) {
            return false;
        } else {
            return true;
        }
    }

    public void actionPerformed(ActionEvent e) {
    }
	
		public void setBackColorAp() {
	//	setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
		viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
        view.setViewFrame(viewFrame);
		
	}
	
		public void sethtLinkColor(String cor) {
		htLinkColor = cor;
	}
	
	public String gethtLinkColor() {
		return htLinkColor;
	}
	
	public void sethtSearchColor(String cor) {
		htSearchColor = cor;
	}
	
	public String gethtSearchColor() {
		return htSearchColor;
	}
	
		public void sethtHintColor(String cor) {
		htHintColor = cor;
	}

	public void sethtGraphColor(String cor) {
        htGraphColor = cor;
    }

    public String gethtGraphColor() {
        return htGraphColor;
    }
	
	public String gethtHintColor() {
		return htHintColor;
	}
	
			public String getHtmlName() {
			return this.getDocumentBase().toString().substring(this.getDocumentBase().toString().lastIndexOf("/")+1, this.getDocumentBase().toString().length());
		}

	public void sethtFontNode(String F) {
		htFont = F;
    
	}
	public void sethtFontSizeNode(String S) {
		htFontSize = S;
	}

  public void setLineGraph(boolean n)
    {
	    lineGraph = n;
    }
    
    public boolean getLineGraph() {
	    return lineGraph;
    }
	void loadTreeAt(HTFileNode no, String filename, int nImporte) {
    }	
	int nImporte = 0;
	void verificaNImporte(HTFileNode node) {
				
	}
	
	int getnImporte() {
		return nImporte;
	}

	void verificaNImportePub() {
		verificaNImporte(root);
	}
	
}

	