
import java.awt.*;
 
public class HTArrow{
	double size = 10;
      Pt    trans = new Pt(0,0);
	double angle = 0; // in degrees
	Pt[] pts = new Pt[]{
			new Pt(0, 0),
			new Pt(1, 0),
			new Pt(1, 0),
			new Pt(.5, .5),
			new Pt(1, 0),
			new Pt(.5, -.5),
			};

public void drawArrow(Graphics gfx){
	drawLine(gfx, 0, 1);
	drawLine(gfx, 2, 3);
	drawLine(gfx, 4, 5);
}
 
public void drawLine(Graphics gfx, int index1, int index2){
	Pt pt1 = rotate(pts[index1]);
	scale(pt1);
	translate(pt1);
	Pt pt2 = rotate(pts[index2]);
	scale(pt2);
	translate(pt2);
	gfx.drawLine((int) pt1.x, (int) pt1.y, (int) pt2.x, (int) pt2.y);
}
 
 
public Pt rotate(Pt pt){
	double ang = angle;
	double cos = Math.cos(ang);
	double sin = Math.sin(ang);
	double x = pt.x * cos - pt.y * sin;
	double y = pt.y * cos + pt.x * sin;
 	return new Pt(x, y);
}
 
public void scale(Pt pt){
	pt.x *= size;
	pt.y *= size;
}


public void setTranslate(Pt p) {
	trans = p;
}
public void translate(Pt pt){
	pt.x += trans.x;
	pt.y += trans.y;
}
   
public void setAngle(Pt point1, Pt point2){
	double thetaRadians = Math.atan2(( point1.y - point2.y),(point1.x - point2.x))+Math.PI; 
	angle = thetaRadians;
} 


}
 
