import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;

/**
 *  Description of the Class
 *
 * @author     silvio
 * @created    19 de Abril de 2005
 */
public class HTColorPicker extends Frame implements ActionListener, AdjustmentListener {

    Frame outerBox;
    Panel colorBox;
    boolean OK = false;
    boolean bExit = false;
    TextField result;
    Scrollbar redSlider, greenSlider, blueSlider;
    TextField redText, greenText, blueText;
    TextField redHex, greenHex, blueHex;
    Button BO, BC;
    GridBagLayout gbLayout;
    GridBagConstraints gbConstraints;
    Color colorRGB;    //Dialog myColor;
    int redValue = 255;
    int greenValue = 255;
    int blueValue = 255;

    /**
     *Constructor for the HTColorPicker object
     *
     * @param  t  Description of the Parameter
     */
    public HTColorPicker(TextField t) {
        result = t;
        bExit = false;
        buildWindow();
    }

    /**
     *Constructor for the HTColorPicker object
     */
    public HTColorPicker() {
        Color c = JColorChooser.showDialog(this, "Escolha uma cor", Color.white);
        colorRGB = c;
    }

    /**
     *  Gets the colorRGB attribute of the HTColorPicker object
     *
     * @return    The colorRGB value
     */
    public Color getColorRGB() {
        return (colorRGB);
    }

    /**
     *  Gets the colorRGBHEX attribute of the HTColorPicker object
     *
     * @return    The colorRGBHEX value
     */
    public String getColorRGBHEX() {
        String red;
        String green;
        String blue;

        red = Integer.toHexString(colorRGB.getRed());
        if (red.length() == 1) {
            red = red + "0";
        }
        green = Integer.toHexString(colorRGB.getGreen());
        if (green.length() == 1) {
            green = green + "0";
        }
        blue = Integer.toHexString(colorRGB.getBlue());
        if (blue.length() == 1) {
            blue = blue + "0";
        }

        return ("0x" + red + green + blue);
    }

    /**
     *  Description of the Method
     *
     * @param  name       Description of the Parameter
     * @param  gridbag    Description of the Parameter
     * @param  c          Description of the Parameter
     * @param  viewFrame  Description of the Parameter
     * @return            Description of the Return Value
     */
    protected Button makebutton(String name, GridBagLayout gridbag, GridBagConstraints c, Frame viewFrame) {
        Button button = new Button(name);
        gridbag.setConstraints(button, c);
        viewFrame.add(button);
        return button;
    }

    /**
     *  Description of the Method
     */
    private void buildWindow() {
        outerBox = new Frame();
        colorBox = new Panel();

        outerBox.setBackground(new Color(redValue, greenValue, blueValue));
        colorBox.setBackground(new Color(redValue, greenValue, blueValue));

        redSlider = new Scrollbar(Scrollbar.HORIZONTAL, redValue, 1, 0, redValue + 1);
        redSlider.setBackground(new Color(redValue, 0, 0));
        redSlider.addAdjustmentListener(this);
        greenSlider = new Scrollbar(Scrollbar.HORIZONTAL, greenValue, 1, 0, greenValue + 1);
        greenSlider.setBackground(new Color(0, greenValue, 0));
        greenSlider.addAdjustmentListener(this);
        blueSlider = new Scrollbar(Scrollbar.HORIZONTAL, blueValue, 1, 0, blueValue + 1);
        blueSlider.setBackground(new Color(0, 0, blueValue));
        blueSlider.addAdjustmentListener(this);

        redText = new TextField("" + redValue, 3);
        redText.addActionListener(this);
        greenText = new TextField("" + greenValue, 3);
        greenText.addActionListener(this);
        blueText = new TextField("" + blueValue, 3);
        blueText.addActionListener(this);

        redText.setEnabled(false);
        greenText.setEnabled(false);
        blueText.setEnabled(false);
        redText.setVisible(false);
        greenText.setVisible(false);
        blueText.setVisible(false);

        redHex = new TextField("" + Integer.toHexString(redValue), 2);
        redHex.addActionListener(this);
        greenHex = new TextField("" + Integer.toHexString(greenValue), 2);
        greenHex.addActionListener(this);
        blueHex = new TextField("" + Integer.toHexString(blueValue), 2);
        blueHex.addActionListener(this);

        redHex.setEnabled(false);
        greenHex.setEnabled(false);
        blueHex.setEnabled(false);

        gbLayout = new GridBagLayout();
        gbConstraints = new GridBagConstraints();
        gbConstraints.insets = new Insets(2, 2, 2, 2);

        outerBox.setLayout(gbLayout);
        //outerBox.setBackground(Color.white);
        outerBox.setBackground(Color.lightGray);

        outerBox.setSize(350, 200);
        outerBox.setTitle("Selecione uma cor:");

        // set colorBox's constraints
        gbConstraints.anchor = GridBagConstraints.WEST;
        gbConstraints.fill = GridBagConstraints.BOTH;
        gbConstraints.weightx = 3;
        gbConstraints.weighty = 4;
        addMe(outerBox, colorBox, gbLayout, gbConstraints, 0, 0, 1, 3);

        // set Hex values' constraints
        gbConstraints.anchor = GridBagConstraints.CENTER;
        gbConstraints.fill = GridBagConstraints.NONE;
        gbConstraints.weightx = gbConstraints.NONE;
        gbConstraints.weighty = gbConstraints.NONE;
        addMe(outerBox, redHex, gbLayout, gbConstraints, 1, 0, 1, 1);
        addMe(outerBox, greenHex, gbLayout, gbConstraints, 1, 1, 1, 1);
        addMe(outerBox, blueHex, gbLayout, gbConstraints, 1, 2, 1, 1);
        /*
         *  / set Text values' constraints
         *  gbConstraints.anchor = GridBagConstraints.CENTER;
         *  gbConstraints.fill = GridBagConstraints.NONE;
         *  gbConstraints.weightx = gbConstraints.NONE;
         *  gbConstraints.weighty = gbConstraints.NONE;
         *  addMe(outerBox, redText, gbLayout, gbConstraints, 2, 0, 1, 1);
         *  addMe(outerBox, greenText, gbLayout, gbConstraints, 2, 1, 1, 1);
         *  addMe(outerBox, blueText, gbLayout, gbConstraints, 2, 2, 1, 1);
         */
        // set sliders' constraints
        gbConstraints.anchor = GridBagConstraints.NORTHEAST;
        gbConstraints.fill = GridBagConstraints.HORIZONTAL;
        gbConstraints.weightx = 3;
        gbConstraints.weighty = 3;
        addMe(outerBox, redSlider, gbLayout, gbConstraints, 2, 0, 1, 1);
        //3
        addMe(outerBox, greenSlider, gbLayout, gbConstraints, 2, 1, 1, 1);
        //3
        addMe(outerBox, blueSlider, gbLayout, gbConstraints, 2, 2, 1, 1);
        //3

        //outerBox.addWindowListener(outerBox);

        gbConstraints.weightx = 2;
        gbConstraints.anchor = GridBagConstraints.SOUTHEAST;
        gbConstraints.gridx = 1;
        gbConstraints.gridy = 3;

        BO = makebutton("OK", gbLayout, gbConstraints, outerBox);
        BO.addActionListener(this);

        gbConstraints.gridx = 2;
        gbConstraints.gridy = 3;

        BC = makebutton("Cancelar", gbLayout, gbConstraints, outerBox);
        BC.addActionListener(this);

        outerBox.setVisible(true);
        colorBox.setVisible(true);
        colorBox.invalidate();
        outerBox.requestFocus();

    }

    /**
     *  Adds a feature to the Me attribute of the HTColorPicker object
     *
     * @param  cup  The feature to be added to the Me attribute
     * @param  o    The feature to be added to the Me attribute
     * @param  gbL  The feature to be added to the Me attribute
     * @param  gbC  The feature to be added to the Me attribute
     * @param  col  The feature to be added to the Me attribute
     * @param  row  The feature to be added to the Me attribute
     * @param  w    The feature to be added to the Me attribute
     * @param  h    The feature to be added to the Me attribute
     */
    private void addMe(Container cup, Component o, GridBagLayout gbL,
            GridBagConstraints gbC, int col, int row, int w, int h) {
        gbC.gridx = col;
        gbC.gridy = row;
        gbC.gridwidth = w;
        gbC.gridheight = h;
        gbL.setConstraints(o, gbC);
        cup.add(o);
    }

    /**
     *  Description of the Method
     *
     * @param  e  Description of the Parameter
     */
    public void actionPerformed(ActionEvent e) {

        if (BO == e.getSource()) {
            outerBox.pack();
            outerBox.dispose();
            OK = true;
            bExit = true;
            result.setText(getColor());
            result.setBackground(new Color(Color.decode(getColor()).getRGB()));
            return;
        }
        if (BC == e.getSource()) {
            outerBox.pack();
            outerBox.dispose();
            OK = false;
            bExit = true;
            return;
        }

        Object s = e.getSource();

        if (s instanceof TextField) {
            if (s == redText) {
                redValue = Integer.parseInt(redText.getText());
                redSlider.setValue(redValue);
                redHex.setText("" + Integer.toHexString(redValue));
            } else if (s == greenText) {
                greenValue = Integer.parseInt(greenText.getText());
                greenSlider.setValue(greenValue);
                greenHex.setText("" + Integer.toHexString(greenValue));
            } else if (s == blueText) {
                blueValue = Integer.parseInt(blueText.getText());
                blueSlider.setValue(blueValue);
                blueHex.setText("" + Integer.toHexString(blueValue));
            }
            colorBox.setBackground(new Color(redValue, greenValue, blueValue));
        }
    }

    /**
     *  Description of the Method
     *
     * @param  e  Description of the Parameter
     */
    public void adjustmentValueChanged(AdjustmentEvent e) {
        Object s = e.getSource();

        if (s instanceof Scrollbar) {
            if (s == redSlider) {
                redText.setText("" + redSlider.getValue());
                redHex.setText("" + Integer.toHexString(redSlider.getValue()));
                redValue = redSlider.getValue();
                redSlider.setBackground(new Color(redValue, 0, 0));
            } else if (s == greenSlider) {
                greenText.setText("" + greenSlider.getValue());
                greenHex.setText("" + Integer.toHexString(greenSlider.getValue()));
                greenValue = greenSlider.getValue();
                greenSlider.setBackground(new Color(0, greenValue, 0));
            } else if (s == blueSlider) {
                blueText.setText("" + blueSlider.getValue());
                blueHex.setText("" + Integer.toHexString(blueSlider.getValue()));
                blueValue = blueSlider.getValue();
                blueSlider.setBackground(new Color(0, 0, blueValue));
            }
            colorBox.setBackground(new Color(redValue, greenValue, blueValue));
        }
    }

    /**
     *  Gets the color attribute of the HTColorPicker object
     *
     * @return    The color value
     */
    public String getColor() {
        String red;
        String green;
        String blue;

        red = redHex.getText().trim();
        if (red.length() == 1) {
            red = red + "0";
        }

        green = greenHex.getText().trim();
        if (green.length() == 1) {
            green = green + "0";
        }

        blue = blueHex.getText().trim();
        if (blue.length() == 1) {
            blue = blue + "0";
        }

        return ("0x" + red + green + blue);
    }
}

