/* 
 * HTDialogLinks.java
 *
 * Bruno 30/06/2008
 *
 */

import java.awt.*;
import java.awt.Font;
import java.awt.event.*;
import java.applet.*;
import java.awt.Graphics;
import java.net.URL;

public class HTDialogLinks extends java.awt.Dialog {

    private String[] Endereco = new String[50];		// String que armazena os enderecos lidos
    private String[] NomeFantasia = new String[50];	// String que armazena os Nomes dos enderecos lidos
    private int[] PossueNome = new int[50];			// Variavel que indica se o endereco possue um NomeFantasia
    private int MaiorTamanho = 0;					// Variavel que guarda o tamanho do maior NomeFantasia
    private int Largura = 150;						// Largura da caixa
    private int UltimoY = 4000;						// Ultima posicao do Y no MouseMove
    private int PosicaoInicial = 50;				// Posicao em que deve ser escrito a primeira string na janela
    private static Applet applet;					// Informacoes da Applet
    private static HTDrawNode No;					// Informacoes do No
    private static HTDraw model;					// Informacoes do Model
    private Graphics d = null;						// Copia do graphics para escrever na caixa
    private FontMetrics fm;							// Propriedades da font utilizada

    public HTDialogLinks(Frame parent, HTDrawNode Node, HTDraw pModel, Applet jApplet) {
        // Create a modal dialog with the specified title and parent
        //super(parent, Node.getName(), true);
        super(new java.awt.Frame(), Node.getName(), true);

        // Coloca o No recebido em uma variavel global
        No = Node;
        model = pModel;

        // Coloca o applet global para poder ser utilizado no Listener do click
        applet = jApplet;

        // Chama a funcao que percorre a string recebida
        PercorreURL();

        // Coloca a cor do fundo e da letra de acordo com o No
        this.setBackground(new Color(Color.decode(No.getColor()).getRGB()));
        this.setForeground(new Color(Color.decode(No.getTextColor()).getRGB()));

        // Ajusta a posicao proximo ao no e dimensiona a caixa
        HTCoordS zs = No.getScreenCoordinates();
        Largura = MaiorTamanho + 30;
        int Altura = ((model.mainFont.getSize()) * ContaLinks()) + 80;//(2*model.mainFont.getSize());
        this.setBounds(zs.x - 10, zs.y + 150, Largura, Altura);
        //this.setMaximumSize(new Dimension(Largura,Altura));
        //this.setMinimumSize(new Dimension(Largura,Altura));
        this.setResizable(false);

        // Layout do popup
        this.setLayout(new BorderLayout(Largura, Altura));

        /* Listener usado para pegar a posicao do click no form.
         *  Quando clicado a funco ClickNoForm  chamada
         */
        addMouseListener(new java.awt.event.MouseAdapter() {

            public void mouseClicked(java.awt.event.MouseEvent evt) {
                int Pos = evt.getY();
                ClickNoForm(evt, Pos);
                HTDialogLinks.this.dispose();
            }
        });

        /* Listener usado para pegar a posicao do mouse no form.
         *  Quando o mouse  movido dentro do form a funcao formMouseMoved() eh chamada
         */
        addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

            public void mouseMoved(java.awt.event.MouseEvent evt) {
                formMouseMoved(evt);
            }
        });

        // Controla quando a janela ganha ou perde o foco
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {

            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
            }

            public void windowLostFocus(java.awt.event.WindowEvent evt) {
                dispose();
            }
        });

        // Listener usado para fechar a janela
        addWindowListener(new java.awt.event.WindowAdapter() {

            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
    }
    // Funcao que trata os cliques no form
    private void formMouseMoved(java.awt.event.MouseEvent evt) {

        int ProximaPos = PosicaoInicial;

        // Verifica se continua na mesma opcao. Isso evita que fique re-desenhando toda hora que mexe o mouse
        if (UltimoY != ((evt.getY() - (PosicaoInicial - fm.getHeight())) / fm.getHeight())) {
            UltimoY = ((evt.getY() - (PosicaoInicial - fm.getHeight())) / fm.getHeight());

            d.setColor(new Color(Color.decode(No.getColor()).getRGB()));
            // Desenha um retangulo que cobre todo o form
            d.fillRect(0, 0, 1280, 1280);

            // Desenha os links
            for (int k = 0; k < ContaLinks(); k++) {
                if ((evt.getY() >= ProximaPos - fm.getHeight()) && (evt.getY() < ProximaPos)) { //20
                    // Boarda preta
                    d.setColor(Color.BLACK); //-14
                    d.fillRect(0, ProximaPos - fm.getHeight() + 2, 1280, fm.getHeight() + 6); //19
                    // Cor do "highlight"
                    d.setColor(new Color(Color.decode(No.getHintColor()).getRGB()));
                    d.fillRect(0, ProximaPos - fm.getHeight() + 4, 1280, fm.getHeight() + 2); //15
                    // Cor da fonte
                    d.setColor(new Color(Color.decode(No.getColor()).getRGB()));
                } else {
                    // Cor da fonte
                    d.setColor(new Color(Color.decode(No.getTextColor()).getRGB()));
                }
                // Desenha no form o nome
                d.drawString(NomeFantasia[k], 10, ProximaPos);

                // Espaco de acordo com o tamanho da font do draw em pixels entre cada nome
                ProximaPos += fm.getHeight();
            }
        }
    }

    // Funcao que trata os cliques no form
    private void ClickNoForm(java.awt.event.MouseEvent evt, int PosUrl) {
        // Chama a funcao que abre a pagina
        AbrePagina(PosUrl, applet);
    }
    // Funcao que pega o link e abre a nova pagina
    private void AbrePagina(int PosUrl, Applet applet) {
        // Posicao do Y menos o valor de ("PosicaoInicial" menos Tamanho da fonte) dividido pelo tamanho da fonte
        int pp = ((PosUrl - (PosicaoInicial - fm.getHeight())) / fm.getHeight());

        try {
            boolean UrlOnError = false;
            URL userUrl = null;
            /* Cria um URL com a posicao recebida por parametro */
            String base = model.getUrlAdr();

            if ((base.length() > 2) && (Endereco[pp].toLowerCase().indexOf("http:") < 0)
                 && (Endereco[pp].toLowerCase().indexOf("file:") < 0)) {
                if (Endereco[pp].charAt(0) != '/') {
                    // Coloca uma "/" no final da string caso nao exista
                    if (base.charAt(base.length() - 1) != '/') {
                        Endereco[pp] = base + "/" + Endereco[pp];
                    }
                } else {
                    Endereco[pp] = base + Endereco[pp];
                }
            }
            try {
                userUrl = new URL(Endereco[pp]);
            } catch (Exception urlError) {
                UrlOnError = true;
            }
            //Verifica se foi possivel criar o URL
            if (!UrlOnError) {
                applet.getAppletContext().showDocument(userUrl, "_blank");
            }
        } catch (Exception e) {
		HTMessage s = new HTMessage("Erro: endereo URL incorretamente formatado.");
            System.out.println("Erro : " + e);
        }
    }
    // Funcao que percorre o URL recebido e separa os enderecos dos nomes
    private void PercorreURL() {
        String Linha;
        int Inicio = 0, InicioNome = 0, FimNome = 0, Tamanho = 0;
        int Posicao = 0;
        String URLs = No.getURL();

        // Verifica se existe o "@!" no final da string
        if (URLs == null || URLs.length() < 2 || (URLs.charAt(URLs.length() - 2) != '@' && URLs.charAt(URLs.length() - 1) != '!')) {
            URLs = URLs + "@!";        // Verifica se a string tem masi que 2 caracteres
        }
        if (URLs.length() > 2) {
            // Percorre a string de URLs e monta a janela PopUp
            for (int h = 0; h < URLs.length(); h++) {
                // Quando encontrar o @, um link  gerado
                if ((h + 1) < URLs.length()) {
                    if ((URLs.charAt(h) == '@' && URLs.charAt(h + 1) == '!') || h == URLs.length() - 1) {
                        // Pega a parte da linha que contem o proximo Nome e Link
                        Linha = URLs.substring(Inicio, h + 1);
                        // Procura o inicio e o final do nome
                        for (int k = 0; k < Linha.length(); k++) {
                            //Inicio
                            if (Linha.charAt(k) == '`' && Linha.charAt(k + 1) == '(') {
                                InicioNome = k + 2;
                                PossueNome[Posicao] = 1;
                            }
                            //Fim
                            if (Linha.charAt(k) == ')' && Linha.charAt(k + 1) == '`') {
                                FimNome = k;
                            }
                        }

                        // Se existe o nome, coloca ele no NomeFantasia, se nao coloca o link no NomeFantasia
                        if (PossueNome[Posicao] == 1) {
                            NomeFantasia[Posicao] = Linha.substring(InicioNome, FimNome).trim(); //.replace(")", "").replace("!", "")
                            //URL  o comeco da string Endereco ate o comeco do InicioNome - 1
                            Endereco[Posicao] = Linha.substring(0, InicioNome - 2).replace('!', ' ').trim(); //.replace("!", "").replace("(", "")
                        } else {
                            // Quando nao existe nome, o final eh o tamanho do Endereco
                            Endereco[Posicao] = NomeFantasia[Posicao] = Linha.substring(0, Linha.length() - 1).replace('!', ' ').trim(); //
                        }

                        // Calcula o tamanho da caixa
                        //Tamanho = No.getStringWidth(NomeFantasia, 0, NomeFantasia.length);
                        char[] nameC = NomeFantasia[Posicao].toCharArray();
                        int nameLength = nameC.length;
                        Tamanho = No.getStringWidth(nameC, 0, nameLength);

                        // Primeira rodada
                        if (Posicao == 0) {
                            MaiorTamanho = Tamanho;
                        } else {
                            // Outras rodadas verifica se eh maior q o MaiorTamanho
                            if (MaiorTamanho < Tamanho) {
                                MaiorTamanho = Tamanho;
                            }
                        }

                        // Posicao na string de URL que deve comecar o proximo endereco
                        Inicio = h + 1;
                        Posicao++;
                    }
                }
            }
        }
    }
    // Funcao que desenha no form os links e nomes fantasias
    public void paint(Graphics g) {
        int ProximaPos = PosicaoInicial;
        // d  um graphics global e tambem  uma copia do g
        d = g.create();

        // Propriedades da fonte
        d.setFont(model.mainFont);
        fm = d.getFontMetrics();

        g.setColor(new Color(Color.decode(No.getTextColor()).getRGB()));

        g.setFont(model.mainFont);
        for (int k = 0; k < ContaLinks(); k++) {
            // Desenha no form o nome
            g.drawString(NomeFantasia[k], 10, ProximaPos);
            // Espaco de 20 pixels entre cada nome
            ProximaPos += fm.getHeight();
        }
    }

    /* Conta quantos links tem na string */
    int ContaLinks() {
        int NumLinks = 0;
        if (No.getURL() != null) {
            for (int i = 0; i < No.getURL().length(); i++) {
                if (No.getURL().charAt(i) == '@' && No.getURL().charAt(i + 1) == '!') {
                    NumLinks++;
                }
            }
            return NumLinks;
        } else {
            System.out.println("Nao possue URL");
            return 0;
        }
    }
    // Funcao que fecha a janela
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                HTDialogLinks dialog = new HTDialogLinks(new java.awt.Frame(), No, model, applet);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
}

